import type { IFramebuffer, IModel, IModelUniform, IRenderOptions, ITexture2D } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class HeatMapModel extends BaseModel {
    protected texture: ITexture2D;
    protected colorTexture: ITexture2D;
    protected heatmapFramerBuffer: IFramebuffer;
    protected heatmapTexture: ITexture2D;
    private intensityModel;
    private colorModel;
    private shapeType;
    private preRampColors;
    private colorModelUniformBuffer;
    private heat3DModelUniformBuffer;
    prerender(): void;
    render(options: Partial<IRenderOptions>): void;
    getUninforms(): IModelUniform;
    initModels(): Promise<IModel[]>;
    buildModels(): Promise<IModel[]>;
    protected registerBuiltinAttributes(): void;
    private buildHeatMapIntensity;
    private buildHeatmap;
    private drawIntensityMode;
    private drawHeatMap;
    private draw3DHeatMap;
    private build3dHeatMap;
    private updateColorTexture;
}
