import type { IModel, ITexture2D } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class LineModel extends BaseModel {
    private textureEventFlag;
    protected texture: ITexture2D;
    protected getCommonUniformsInfo(): {
        uniformsArray: number[];
        uniformsLength: number;
        uniformsOption: {
            [key: string]: any;
        };
    };
    initModels(): Promise<IModel[]>;
    clearModels(): void;
    buildModels(): Promise<IModel[]>;
    /**
     * 根据参数获取不同的 shader 代码
     * @returns
     */
    getShaders(): {
        frag: string;
        vert: string;
        type: string;
    };
    protected registerBuiltinAttributes(): void;
    private updateTexture;
}
