import type { IModel, IModelUniform, IRenderOptions, ITexture2D } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class WindModel extends BaseModel {
    protected texture: ITexture2D;
    private colorModel;
    private wind;
    private imageCoords;
    private sizeScale;
    private frequency;
    private cacheZoom;
    render(options: Partial<IRenderOptions>): void;
    getUninforms(): IModelUniform;
    initModels(): Promise<IModel[]>;
    getWindSize(): {
        imageWidth: number;
        imageHeight: number;
    };
    buildModels(): Promise<IModel[]>;
    clearModels(): void;
    protected registerBuiltinAttributes(): void;
    private getZoomScale;
    private drawWind;
    private drawColorMode;
}
