"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _BaseLayer = _interopRequireDefault(require("../core/BaseLayer"));
var _models = require("./models");
// import type { ILayerConfig } from '@antv/l7-core';

class CanvasLayer extends _BaseLayer.default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2.default)(this, "type", 'CanvasLayer');
  }
  getDefaultConfig() {
    return {
      zIndex: 3,
      contextType: 'canvas2d',
      trigger: 'change'
    };
  }
  buildModels() {
    var _this = this;
    return (0, _asyncToGenerator2.default)(function* () {
      _this.layerModel = new _models.CanvasModel(_this);
      yield _this.initLayerModels();
    })();
  }
  getModelType() {
    return this.getLayerConfig().contextType || 'canvas2d';
  }
  draw(draw) {
    this.updateLayerConfig({
      draw
    });
    this.render();
    return this;
  }
  getLayerConfig() {
    const config = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, this.getDefaultConfig()), super.getLayerConfig());
    if (config.zIndex < 3) {
      config.zIndex = 3;
    }
    return config;
  }
  render() {
    var _this$layerModel;
    (_this$layerModel = this.layerModel) === null || _this$layerModel === void 0 || _this$layerModel.renderCanvas();
    return this;
  }
  getCanvas() {
    var _this$layerModel2;
    return (_this$layerModel2 = this.layerModel) === null || _this$layerModel2 === void 0 ? void 0 : _this$layerModel2.canvas;
  }
  show() {
    const canvas = this.getCanvas();
    if (canvas) {
      canvas.style.display = 'unset';
    }
    return this;
  }
  hide() {
    const canvas = this.getCanvas();
    if (canvas) {
      canvas.style.display = 'none';
    }
    return this;
  }
  destroy() {
    this.layerModel.removeCanvas();
    super.destroy();
  }
}
exports.default = CanvasLayer;