import type { IModel, ITexture2D } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class BaseEarthModel extends BaseModel {
    protected texture: ITexture2D;
    private earthTime;
    private sunX;
    private sunY;
    private sunZ;
    private sunRadius;
    protected getCommonUniformsInfo(): {
        uniformsArray: number[];
        uniformsLength: number;
        uniformsOption: {
            [key: string]: any;
        };
    };
    setEarthTime(time: number): void;
    initModels(): Promise<IModel[]>;
    clearModels(): string;
    buildModels(): Promise<IModel[]>;
    protected registerBuiltinAttributes(): void;
}
