"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _l7Core = require("@antv/l7-core");
// import TileLayer from '../tile/core/BaseLayer';
/**
 * Layer Model 初始化，更新，销毁
 */
class LayerModelPlugin {
  build(layer) {
    return (0, _asyncToGenerator2.default)(function* () {
      // 更新Model 配置项 style options
      layer.prepareBuildModel();
      // 初始化 Model
      yield layer.buildModels();
    })();
  }
  initLayerModel(layer) {
    var _this = this;
    return (0, _asyncToGenerator2.default)(function* () {
      yield _this.build(layer);
      layer.styleNeedUpdate = false;
    })();
  }
  prepareLayerModel(layer) {
    var _this2 = this;
    return (0, _asyncToGenerator2.default)(function* () {
      yield _this2.build(layer);
      layer.styleNeedUpdate = false;
    })();
  }
  apply(layer) {
    var _this3 = this;
    layer.hooks.init.tapPromise('LayerModelPlugin', /*#__PURE__*/(0, _asyncToGenerator2.default)(function* () {
      if (layer.getSource().isTile) {
        layer.prepareBuildModel();
        return;
      }
      layer.log(_l7Core.IDebugLog.BuildModelStart, _l7Core.ILayerStage.INIT);
      yield _this3.initLayerModel(layer);
      layer.log(_l7Core.IDebugLog.BuildModelEnd, _l7Core.ILayerStage.INIT);
    }));
    layer.hooks.beforeRenderData.tapPromise('LayerModelPlugin', /*#__PURE__*/function () {
      var _ref2 = (0, _asyncToGenerator2.default)(function* (flag) {
        if (!flag) {
          // TileLayer  不需要rebuilder
          return false;
        }
        if (layer.getSource().isTile) {
          return false;
        }
        layer.log(_l7Core.IDebugLog.BuildModelStart, _l7Core.ILayerStage.UPDATE);
        yield _this3.prepareLayerModel(layer);
        layer.log(_l7Core.IDebugLog.BuildModelEnd, _l7Core.ILayerStage.UPDATE);
        return true;
      });
      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }());
  }
}
exports.default = LayerModelPlugin;