export declare function createProgram(gl: WebGLRenderingContext, vshader: string, fshader: string): WebGLProgram | null;
export declare function loadShader(gl: WebGLRenderingContext, type: number, source: string): WebGLShader | null;
export declare function createTexture(gl: WebGLRenderingContext, filter: any, data: any, width: number, height: number): WebGLTexture | null;
export declare function createDataTexture(gl: WebGLRenderingContext, filter: any, data: any): WebGLTexture | null;
export declare function bindTexture(gl: WebGLRenderingContext, texture: WebGLTexture, unit: number): void;
export declare function createBuffer(gl: WebGLRenderingContext, data: Float32Array): WebGLBuffer | null;
export declare function bindAttriBuffer(gl: WebGLRenderingContext, attrName: string, vertices: number, count: number, program: WebGLProgram): {
    buffer: WebGLBuffer | null;
    attr: number;
    count: number;
};
export declare function bindAttriIndicesBuffer(gl: WebGLRenderingContext, indices: Uint8Array): WebGLBuffer;
export declare function bindUnifrom(gl: WebGLRenderingContext, unifromName: string, data: number | Float32List, program: WebGLProgram, vec: string): WebGLUniformLocation | null;
export declare function setUnifrom(gl: WebGLRenderingContext, location: WebGLUniformLocation, data: number | Float32List, vec: string): void;
export declare function initFramebuffer(gl: WebGLRenderingContext): {
    FRAMEBUFFER: WebGLFramebuffer | null;
    OFFER_SCREEN_WIDTH: number;
    OFFER_SCREEN_HEIGHT: number;
};
